unit ddidexConfigForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,DDIDEX,DInput,ddidexConfigFormLorR;

type
  TddidexConfigDialog = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    GroupBox1: TGroupBox;
    ScrollBox1: TScrollBox;
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    GroupBox3: TGroupBox;
    Edit3: TEdit;
    Edit4: TEdit;
    GroupBox4: TGroupBox;
    Edit5: TEdit;
    Edit6: TEdit;
    GroupBox5: TGroupBox;
    Edit7: TEdit;
    Edit8: TEdit;
    GroupBox6: TGroupBox;
    Edit9: TEdit;
    Edit10: TEdit;
    GroupBox7: TGroupBox;
    Edit11: TEdit;
    Edit12: TEdit;
    GroupBox8: TGroupBox;
    Edit13: TEdit;
    Edit14: TEdit;
    GroupBox9: TGroupBox;
    Edit15: TEdit;
    Edit16: TEdit;
    GroupBox10: TGroupBox;
    Edit17: TEdit;
    Edit18: TEdit;
    GroupBox11: TGroupBox;
    Edit19: TEdit;
    Edit20: TEdit;
    GroupBox12: TGroupBox;
    Edit21: TEdit;
    Edit22: TEdit;
    GroupBox13: TGroupBox;
    Edit23: TEdit;
    Edit24: TEdit;
    GroupBox14: TGroupBox;
    Edit25: TEdit;
    Edit26: TEdit;
    GroupBox15: TGroupBox;
    Edit27: TEdit;
    Edit28: TEdit;
    GroupBox16: TGroupBox;
    Edit29: TEdit;
    Edit30: TEdit;
    GroupBox17: TGroupBox;
    Edit31: TEdit;
    Edit32: TEdit;
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    DI:TDDIDEX;
    LRDiag:TLRDiag;//:1;E:2;
  public
    { Public 錾 }
    procedure showmodal(ddidex:TDDIDEX);

    function DIKeyToWinKey(dik:Integer):Integer;
    function WinKeyToDIKey(wkc:char):Integer;

    function DIKeyToStr(dik:Integer):String;
  end;

  var ddidexConfigDialog:TddidexConfigDialog;

implementation

{$R *.dfm}

procedure TddidexConfigDialog.showmodal(ddidex:TDDIDEX);
begin
    DI:=ddidex;
    inherited showmodal;
end;

function TddidexConfigDialog.DIKeyToWinKey(dik:Integer):Integer;
begin
   // Case dik of


   // end;
end;

function TddidexConfigDialog.WinKeyToDIKey(wkc:char):Integer;
var r:integer;
    wk:Integer;
begin
    wk:=Ord(wkc);
    Case wk of
        VK_BACK     :   r:=DIK_BACK;
        VK_TAB      :   r:=DIK_TAB;
        VK_RETURN   :   r:=DIK_RETURN;

        //ނ
        VK_SHIFT    :begin
            Case LRDiag.ShowModal of
                -1  :  r:=DIK_LSHIFT;
                1   :  r:=DIK_RSHIFT;
                else    r:=DIK_LSHIFT;
            end;
        end;
        VK_CONTROL  :begin
            Case LRDiag.ShowModal of
                -1  :  r:=DIK_LCONTROL;
                1   :  r:=DIK_RCONTROL;
                else    r:=DIK_LCONTROL;
            end;
        end;
        VK_MENU     :begin
            Case LRDiag.ShowModal of
                -1  :  r:=DIK_LALT;
                1   :  r:=DIK_RALT;
                else    r:=DIK_LALT;
            end;
        end;


        VK_ESCAPE   :   r:=DIK_ESCAPE;
        VK_SPACE    :   r:=DIK_SPACE;
        VK_PRIOR    :   r:=DIK_PGUP;
        VK_NEXT     :   r:=DIK_PGDN;
        VK_END      :   r:=DIK_END;
        VK_HOME     :   r:=DIK_HOME;
        VK_LEFT     :   r:=DIK_LEFT;
        VK_UP       :   r:=DIK_UP;
        VK_RIGHT    :   r:=DIK_RIGHT;
        VK_DOWN     :   r:=DIK_DOWN;
        VK_INSERT   :   r:=DIK_INSERT;
        VK_DELETE   :   r:=DIK_DELETE;

        $30         :   r:=DIK_0;           //0
        $31..$39    :   r:=DIK_1+wk-$31;    //1-9

        $41     :   r:=DIK_A;
        $42     :   r:=DIK_B;
        $43     :   r:=DIK_C;
        $44     :   r:=DIK_D;
        $45     :   r:=DIK_E;
        $46     :   r:=DIK_F;
        $47     :   r:=DIK_G;
        $48     :   r:=DIK_H;
        $49     :   r:=DIK_I;
        $4A     :   r:=DIK_J;
        $4B     :   r:=DIK_K;
        $4C     :   r:=DIK_L;
        $4D     :   r:=DIK_M;
        $4E     :   r:=DIK_N;
        $4F     :   r:=DIK_O;
        $50     :   r:=DIK_P;
        $51     :   r:=DIK_Q;
        $52     :   r:=DIK_R;
        $53     :   r:=DIK_S;
        $54     :   r:=DIK_T;
        $55     :   r:=DIK_U;
        $56     :   r:=DIK_V;
        $57     :   r:=DIK_W;
        $58     :   r:=DIK_X;
        $59     :   r:=DIK_Y;
        $5A     :   r:=DIK_Z;

        VK_NUMPAD0              :   r:=DIK_NUMPAD0;
        VK_NUMPAD1..VK_NUMPAD3  :   r:=DIK_NUMPAD1+wk-VK_NUMPAD1;
        VK_NUMPAD4..VK_NUMPAD6  :   r:=DIK_NUMPAD4+wk-VK_NUMPAD4;
        VK_NUMPAD7..VK_NUMPAD9  :   r:=DIK_NUMPAD7+wk-VK_NUMPAD7;
        VK_MULTIPLY             :   r:=DIK_NUMPADSTAR;
        VK_ADD                  :   r:=DIK_NUMPADPLUS;
        VK_SUBTRACT             :   r:=DIK_NUMPADMINUS;
        VK_DECIMAL              :   r:=DIK_NUMPADPERIOD;
        VK_DIVIDE               :   r:=DIK_NUMPADSLASH;

        VK_F1..VK_F10   :   r:=DIK_F1+wk-VK_F1;
        VK_F11          :   r:=DIK_F11;
        VK_F12          :   r:=DIK_F12;

        $BA     :   r:=DIK_COLON;
        $BB     :   r:=DIK_SEMICOLON;
        $BC     :   r:=DIK_COMMA;
        $BD     :   r:=DIK_MINUS;
        $BE     :   r:=DIK_PERIOD;
        $BF     :   r:=DIK_SLASH;
        $C0     :   r:=DIK_AT;

        $DB     :   r:=DIK_LBRACKET;
        $DC     :   r:=DIK_YEN;
        $DD     :   r:=DIK_RBRACKET;
        $DE     :   r:=DIK_CIRCUMFLEX;

        else    r:=Ord(wkc);
    end;
    Result:=r;
end;

function TddidexConfigDialog.DIKeyToStr(dik:Integer):String;
var r:string;
begin
    Case dik of
        DIK_ESCAPE  :   r:='ESC';

        DIK_F1  :   r:='F1';
        DIK_F2  :   r:='F2';
        DIK_F3  :   r:='F3';
        DIK_F4  :   r:='F4';
        DIK_F5  :   r:='F5';
        DIK_F6  :   r:='F6';
        DIK_F7  :   r:='F7';
        DIK_F8  :   r:='F8';
        DIK_F9  :   r:='F9';
        DIK_F10 :   r:='F10';
        DIK_F11 :   r:='F11';
        DIK_F12 :   r:='F12';

        DIK_INSERT  :   r:='Insert';
        DIK_DELETE  :   r:='Delete';

        DIK_1   :   r:='1';
        DIK_2   :   r:='2';
        DIK_3   :   r:='3';
        DIK_4   :   r:='4';
        DIK_5   :   r:='5';
        DIK_6   :   r:='6';
        DIK_7   :   r:='7';
        DIK_8   :   r:='8';
        DIK_9   :   r:='9';
        DIK_0   :   r:='0';

        DIK_MINUS       :   r:='-';
        DIK_CIRCUMFLEX  :   r:='^';
        DIK_YEN         :   r:='\';
        DIK_BACK        :   r:='BackSpace';
        DIK_TAB         :   r:='TAB';

        DIK_Q   :   r:='Q';
        DIK_W   :   r:='W';
        DIK_E   :   r:='E';
        DIK_R   :   r:='R';
        DIK_T   :   r:='T';
        DIK_Y   :   r:='Y';
        DIK_U   :   r:='U';
        DIK_I   :   r:='I';
        DIK_O   :   r:='O';
        DIK_P   :   r:='P';

        DIK_AT          :   r:='@';
        DIK_LBRACKET    :   r:='[';
        DIK_RETURN      :   r:='Enter';

        DIK_A   :   r:='A';
        DIK_S   :   r:='S';
        DIK_D   :   r:='D';
        DIK_F   :   r:='F';
        DIK_G   :   r:='G';
        DIK_H   :   r:='H';
        DIK_J   :   r:='J';
        DIK_K   :   r:='K';
        DIK_L   :   r:='L';

        DIK_SEMICOLON   :   r:=';';
        DIK_COLON       :   r:=':';
        DIK_RBRACKET    :   r:=']';

        DIK_LSHIFT      :   r:='LShift';

        DIK_Z   :   r:='Z';
        DIK_X   :   r:='X';
        DIK_C   :   r:='C';
        DIK_V   :   r:='V';
        DIK_B   :   r:='B';
        DIK_N   :   r:='N';
        DIK_M   :   r:='M';

        DIK_COMMA   :   r:=',';
        DIK_PERIOD  :   r:='.';
        DIK_SLASH   :   r:='/';

        DIK_RSHIFT  :   r:='RShift';

        DIK_LCONTROL    :   r:='LControl';
        DIK_LALT        :   r:='LAlt';
        DIK_SPACE       :   r:='SpaceBar';
        DIK_RALT        :   r:='RAlt';
        DIK_RCONTROL    :   r:='RControl';

        DIK_LEFT    :   r:='';
        DIK_UP      :   r:='';
        DIK_RIGHT   :   r:='';
        DIK_DOWN    :   r:='';

        DIK_PGUP    :   r:='PageUp';
        DIK_PGDN    :   r:='PageDown';
        DIK_HOME    :   r:='Home';
        DIK_END     :   r:='End';

        DIK_NUMPAD0     :   r:='0(Numpad)';
        DIK_NUMPAD1     :   r:='1(Numpad)';
        DIK_NUMPAD2     :   r:='2(Numpad)';
        DIK_NUMPAD3     :   r:='3(Numpad)';
        DIK_NUMPAD4     :   r:='4(Numpad)';
        DIK_NUMPAD5     :   r:='5(Numpad)';
        DIK_NUMPAD6     :   r:='6(Numpad)';
        DIK_NUMPAD7     :   r:='7(Numpad)';
        DIK_NUMPAD8     :   r:='8(Numpad)';
        DIK_NUMPAD9     :   r:='9(Numpad)';

        DIK_NUMPADSTAR  :   r:='*(Numpad)';
        DIK_NUMPADPLUS  :   r:='+(Numpad)';
        DIK_NUMPADMINUS :   r:='-(Numpad)';
        DIK_NUMPADPERIOD:   r:='.(Numpad)';
        DIK_NUMPADSLASH :   r:='/(Numpad)';

        else    r:='Ή(0x'+IntToHex(dik,2)+')';
    end;
    Result:='( '+r+' )';
end;

procedure TddidexConfigDialog.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    TEdit(Sender).Text:=DIKeyToStr(WinKeyToDIKey(char(Key)));
end;

procedure TddidexConfigDialog.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
    Key:=#0;
end;

procedure TddidexConfigDialog.FormCreate(Sender: TObject);
begin
    LRDiag:=TLRDiag.Create(Self);
end;

procedure TddidexConfigDialog.FormDestroy(Sender: TObject);
begin
    LRDiag.Release;
end;

end.
